﻿// Paddle_Emulator.cpp 

/* (C) 2022 JH4VAJ */

#define VERSION "0.910"


#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <wchar.h>
#include <conio.h>
#include <string>
#include <regex>
// #include <algorithm>
#include <unordered_map> 

// #pragma comment(lib, "winmm.lib")

#define PORT_PATH_BUFSZ 256
#define STR_PROMPT      "> "
#define CHAR_COMMAND    '!'

#define KEY_SPEED_DEFAULT   15  /* WPM */
#define KEY_SPEED_MIN       5   /* WPM */
#define KEY_SPEED_MAX       60  /* WPM */

#define ADJ_SLEEP           (-4)  /* Sleep()の微調整 */

wchar_t const com_port_num_list[][4] = {    // 美しくないけど、他に思いつかず…
    L"1", L"2", L"3", L"4", L"5", L"6", L"7", L"8", L"9", L"10",
    L"11", L"12", L"13", L"14", L"15", L"16", L"17", L"18", L"19", L"20",
    L"21", L"22", L"23", L"24", L"25", L"26", L"27", L"28", L"29", L"30",
    L"31", L"32", L"33", L"34", L"35", L"36", L"37", L"38", L"39", L"40",
    L"41", L"42", L"43", L"44", L"45", L"46", L"47", L"48", L"49", L"50",
    L"51", L"52", L"53", L"54", L"55", L"56", L"57", L"58", L"59", L"60",
    L"61", L"62", L"63", L"64", L"65", L"66", L"67", L"68", L"69", L"70",
    L"71", L"72", L"73", L"74", L"75", L"76", L"77", L"78", L"79", L"80",
    L"81", L"82", L"83", L"84", L"85", L"86", L"87", L"88", L"89", L"90",
    L"91", L"92", L"93", L"94", L"95", L"96", L"97", L"98", L"99", L"100",
    L"101", L"102", L"103", L"104", L"105", L"106", L"107", L"108", L"109", L"110",
    L"111", L"112", L"113", L"114", L"115", L"116", L"117", L"118", L"119", L"120",
    L"121", L"122", L"123", L"124", L"125", L"126", L"127", L"128", L"129", L"130",
    L"131", L"132", L"133", L"134", L"135", L"136", L"137", L"138", L"139", L"140",
    L"141", L"142", L"143", L"144", L"145", L"146", L"147", L"148", L"149", L"150",
    L"151", L"152", L"153", L"154", L"155", L"156", L"157", L"158", L"159", L"160",
    L"161", L"162", L"163", L"164", L"165", L"166", L"167", L"168", L"169", L"170",
    L"171", L"172", L"173", L"174", L"175", L"176", L"177", L"178", L"179", L"180",
    L"181", L"182", L"183", L"184", L"185", L"186", L"187", L"188", L"189", L"190",
    L"191", L"192", L"193", L"194", L"195", L"196", L"197", L"198", L"199", L"200",
    L"201", L"202", L"203", L"204", L"205", L"206", L"207", L"208", L"209", L"210",
    L"211", L"212", L"213", L"214", L"215", L"216", L"217", L"218", L"219", L"220",
    L"221", L"222", L"223", L"224", L"225", L"226", L"227", L"228", L"229", L"230",
    L"231", L"232", L"233", L"234", L"235", L"236", L"237", L"238", L"239", L"240",
    L"241", L"242", L"243", L"244", L"245", L"246", L"247", L"248", L"249", L"250",
    L"251", L"252", L"253", L"254", L"255", L"256"
};

std::unordered_map<char, std::string> cw_code = {
        {'a', ".-"},    {'b', "-..."},  {'c', "-.-."},  {'d', "-.."},   {'e', "."},
        {'f', "..-."},  {'g', "--."},   {'h', "...."},  {'i', ".."},    {'j', ".---"},
        {'k', "-.-"},   {'l', ".-.."},  {'m', "--"},    {'n', "-."},    {'o', "---"},
        {'p', ".--."},  {'q', "--.-"},  {'r', ".-."},   {'s', "..."},   {'t', "-"},
        {'u', "..-"},   {'v', "...-"},  {'w', ".--"},   {'x', "-..-"},  {'y', "-.--"},
        {'z', "--.."},
        {'1', ".----"}, {'2', "..---"}, {'3', "...--"}, {'4', "....-"}, {'5', "....."},
        {'6', "-...."}, {'7', "--..."}, {'8', "---.."}, {'9', "----."}, {'0', "-----"},
        {'.', ".-.-.-"},{',', "--..--"},{':', "---..."},{'?', "..--.."},{'\'', ".----."},
        {'-', "-....-"},{'(', "-.--."}, {')', "-.--.-"},{'/', "-..-."}, {'=', "-...-"},
        {'+', ".-.-."}, {'"', ".-..-."},{'*', "-..-"},  {'@', ".--.-."},
        {'_', "..--.-"},{'^', "......"},
        {' ', " "},     {'~', "~"}
};

const char  macro_chars[] = "#$%&|";    // マクロで使用する文字

char*   my_name;

int     com_port_num;
int     time_dit, time_dah, time_spc, time_char_spc, time_word_spc;
int     adj_wait_1st_char;           // パドル操作タイミングの微調整時間

bool    flg_longer_interval;
bool    flg_break;

bool    flg_is_straight_key;    // straight key: TRUE, paddle: FALSE

DWORD   pin_dit_set, pin_dit_clr, pin_dah_set, pin_dah_clr;

HANDLE  hCOM;

int     flg_echoback;           // 0: no echo (default), 1: echo, 2: echo code




BOOL WINAPI CtrlHandler(DWORD dwCtrlType)
{
    switch (dwCtrlType) {
        case CTRL_C_EVENT:
            flg_break = TRUE;   // 符号送出中止
            break;
        case CTRL_BREAK_EVENT:
        case CTRL_CLOSE_EVENT:
        case CTRL_LOGOFF_EVENT:
            CloseHandle(hCOM);
            exit(1);
            break;
        case CTRL_SHUTDOWN_EVENT:
        default:
            break;
    }

    return(TRUE);
}



void char_to_cw(char c, bool flg_nospace)
{
    int code_len;
    int time_adj_paddle_on;
    int i;

    time_adj_paddle_on = (flg_is_straight_key == TRUE) ? (time_dit / 6) : 0;

    code_len = (int)cw_code[c].length();

    // timeBeginPeriod(1);

    if (flg_echoback > 0) {
        // std::cout << (int)cw_code[c].length() << std::endl;
        std::cout << c;
        //std::cout << cw_code[c] << " ";
    }


    for (i = 0; i < code_len; i++) {
        if (flg_break == TRUE) {
            break;
        }

        if (flg_echoback >= 2) {
            std::cout << ' ' << cw_code[c][i];
        }

        switch (cw_code[c][i]) {
            case '.' :
                EscapeCommFunction(hCOM, pin_dit_set);
                Sleep(time_dit - time_adj_paddle_on + ADJ_SLEEP);
                EscapeCommFunction(hCOM, pin_dit_clr);
                if (i == 0) {
                    Sleep(time_spc + time_adj_paddle_on - adj_wait_1st_char + ADJ_SLEEP);
                }
                else {
                    Sleep(time_spc + time_adj_paddle_on - 0 + ADJ_SLEEP);
                }
                break;
            case '-' :
                EscapeCommFunction(hCOM, pin_dah_set);
                Sleep(time_dah - time_adj_paddle_on + ADJ_SLEEP);
                EscapeCommFunction(hCOM, pin_dah_clr);
                if (i == 0) {
                    Sleep(time_spc + time_adj_paddle_on - adj_wait_1st_char + ADJ_SLEEP);
                }
                else {
                    Sleep(time_spc + time_adj_paddle_on - 0 + ADJ_SLEEP);
                }
                break;
            case ' ' :
                Sleep(time_word_spc + ADJ_SLEEP);
                // std::cout << "WORD_SPC_TIME" << std::endl;
                break;
            default :
                break;
        }
    }


    if ((c != ' ') && (flg_nospace == FALSE)) {
        // Sleep(time_char_spc + (adj_wait_1st_char / 2) + ADJ_SLEEP);
        Sleep(time_char_spc + adj_wait_1st_char + ADJ_SLEEP);
        // std::cout << "CHAR_SPC_TIME" << std::endl;
    }

    if (flg_echoback >= 2) {
        std::cout << std::endl;
    }

    // timeEndPeriod(1);

    return;
}



bool open_com_port(char s[])
{
    WCHAR com_port[PORT_PATH_BUFSZ] = L"\\\\.\\COM";

    int port_num;

    if (com_port_num != 0) {
        CloseHandle(hCOM);  // すでに開いているハンドルを閉じる
    }

    port_num = strtol(s, NULL, 10);

    if ((port_num >= 1) && (port_num <= 256)) {
        com_port_num = port_num;
    }
    else {
        std::cout << "COMポートは1～256です" << std::endl;
        return(FALSE);
    }

    wcscat_s(com_port, PORT_PATH_BUFSZ, com_port_num_list[com_port_num - 1]);


    // std::wcout << com_port << std::endl;

    hCOM = CreateFile(com_port, 0, 0, NULL, OPEN_EXISTING, 0, NULL);
    if (hCOM == INVALID_HANDLE_VALUE) {
        std::wcout << "COMポート" << com_port_num << "を開けませんでした" << std::endl;
        return(FALSE);
    }

    EscapeCommFunction(hCOM, CLRRTS);
    EscapeCommFunction(hCOM, CLRDTR);

    return(TRUE);
}



bool is_macro(char c)
{
    int i;

    for (i = 0; i < (int)strlen(macro_chars); i++) {
        if (c == macro_chars[i]) {
            return(TRUE);
        }
    }

    return(FALSE);
}


int keying_speed_wpm_to_ms(int speed_wpm)
{
    return(60000 / (speed_wpm * 50));   // PARIS -> 50 dits
}


bool set_keying_speed(char s[])
{
    int speed_min_ms, speed_max_ms;

    int time_dit_tmp;

    speed_min_ms = keying_speed_wpm_to_ms(KEY_SPEED_MAX);
    speed_max_ms = keying_speed_wpm_to_ms(KEY_SPEED_MIN);

    time_dit_tmp = strtol(s, NULL, 10);

    if (strstr(s, "m") != NULL) { // ms
        if ((time_dit_tmp < speed_min_ms) || (speed_max_ms < time_dit_tmp) ) {
            std::cout << "速度が指定可能範囲（" << speed_min_ms
                        << "～" << speed_max_ms << "ms）外です" << std::endl;
            return(FALSE);
        }
    }
    else {  // WPM
        if ((time_dit_tmp < KEY_SPEED_MIN) || (KEY_SPEED_MAX < time_dit_tmp)) {
            std::cout << "速度が指定可能範囲（" << KEY_SPEED_MIN
                        << "～" << KEY_SPEED_MAX << "WPM）外です" << std::endl;
            return(FALSE);
        }
        else {
            time_dit_tmp = keying_speed_wpm_to_ms(time_dit_tmp);
        }
    }

    if (strstr(s, "i") != NULL) {         // 文字間隔を少し長めにする
        flg_longer_interval = TRUE;
    }
    else {
        flg_longer_interval = FALSE;
    }

    time_dit = time_dit_tmp;
    time_dah = time_dit * 3;

    if (flg_is_straight_key == TRUE) {
        adj_wait_1st_char = 0;
        time_spc = time_dit;
    }
    else {
        adj_wait_1st_char = time_dit / 10;   // パドル操作タイミング調整。固定値よりも多少良さそう。
        time_spc = time_dit - (adj_wait_1st_char / 2);
    }
    // std::cout << time_spc << std::endl;

    if (flg_longer_interval == TRUE) {         // 文字間隔を少し長めにする
        time_char_spc = time_dit * (3 - 1 + 2); // 5短点 - 文字間隔
        time_word_spc = time_dit * (7 - 1 + 2); // 9短点 - 語間隔
    }
    else {                                      // ノーマル
        time_char_spc = time_dit * (3 - 1);     // 3短点（文字の後には必ず1短点分の空白があるため）
        time_word_spc = time_dit * (7 - 1);     // 7短点
    }
    
    return(TRUE);
}




bool set_ctrl_line(char s[])
{
    bool ret = TRUE;

    switch (s[0]) {
        case 't':
        case 'T':
        case 'l':
        case 'L':
        case 'r':
        case 'R':
            break;
        default:
            ret = FALSE;    // 不正文字
            break;
    }

    switch (s[1]) {
        case '\0':
        case 't':
        case 'T':
        case 'l':
        case 'L':
        case 'r':
        case 'R':
            break;
        default:
            ret = FALSE;    // 不正文字
            break;
    }

    if (ret == TRUE) {
        switch (s[0]) {
            case 't':
            case 'T':
            case 'l':
            case 'L':
                pin_dit_set = SETRTS;
                pin_dit_clr = CLRRTS;
                break;
            case 'r':
            case 'R':
                pin_dit_set = SETDTR;
                pin_dit_clr = CLRDTR;
                break;
            default:
                break;
        }

        switch (s[1]) {
            case '\0':
                pin_dah_set = pin_dit_set;
                pin_dah_clr = pin_dit_clr;
                break;
            case 't':
            case 'T':
            case 'l':
            case 'L':
                pin_dah_set = SETRTS;
                pin_dah_clr = CLRRTS;
                break;
            case 'r':
            case 'R':
                pin_dah_set = SETDTR;
                pin_dah_clr = CLRDTR;
                break;
            default:
                break;
        }

        if (pin_dah_set == pin_dit_set) {
            flg_is_straight_key = TRUE;
        }
        else {
            flg_is_straight_key = FALSE;
        }
    }
    else {
        std::cout << "ピン割当ての文字が正しくありません" << std::endl;
    }

    return(ret);
}





void set_macro_code(char s[])
{
    int i;


    for (i = 0; i < (int)strlen(macro_chars); i++) {
        if (s[0] == macro_chars[i]) {
            cw_code[s[0]] = &s[1];
            break;
        }
    }

    return;
}




std::string to_lower_case(std::string s)
{
    std::string str_ret;
    int i;

    for (i = 0; i <= (int)s.length(); i++) {
        str_ret += std::tolower(s[i]);
    }

    return(str_ret);
}


void print_com_port_num()
{
    std::cout << "COM" << com_port_num << std::endl;

    return;
}


void print_speed()
{
    std::cout << (60000 / (time_dit * 50)) << " WPM (" << time_dit << " ms/dit)"
        << ", interval: " << (flg_longer_interval ? "longer" : "normal") << std::endl;

    return;
}


void print_pin_assign()
{
    std::cout
        << "dit: " << ((pin_dit_set == SETRTS) ? "tip" : "ring") << "; "
        << "dah: " << ((pin_dah_set == SETRTS) ? "tip" : "ring")
        << std::endl;

    return;
}


void print_usage()
{
    int i;

    std::cout << "Usage: " << my_name << " ComPortNum [Speed tr|rt|t|r] [";
    for (i = 0; i < (int)strlen(macro_chars); i++) {
        std::cout << macro_chars[i] << "MACRO"
            << ((i >= ((int)strlen(macro_chars) - 1)) ? "" : " ");
    }
    std::cout << "]" << std::endl;
    std::cout << "\tSpeed: 5 - 50 [WPM] OR 20m - 250m [ms/dit], i - longer interval" << std::endl;
    std::cout << "\tDefault: Speed - 15WPM(80ms/dit), dit: tip, dah: ring" << std::endl;
    std::cout << "\n    e.g." << std::endl;
    std::cout << "\t" << my_name << " 3\n"
        << "\t\t" << "COM3\n" << std::endl;
    std::cout << "\t" << my_name << " 10 15 rt\n"
        << "\t\t" << "COM10, 15WPM, dit:ring dah:tip\n" << std::endl;
    std::cout << "\t" << my_name << " 5 20 $vvv %~VA\n"
        << "\t\t" << "COM5, 20WPM, dit:tip dah:ring Macro$ Macro%\n" << std::endl;
    std::cout << "\t" << my_name << " 8 50mi t #599  \"%cq cq cq de \" \"|73\"\n"
        << "\t\t" << "COM8, 50ms/dit(inteval), dit:tip dah:tip, Macro# Macro% Macro|" << std::endl;;
    std::cout << "\n    commands: " << CHAR_COMMAND << "echo " << CHAR_COMMAND
        << "echocode " << CHAR_COMMAND
        << "noecho "
        << CHAR_COMMAND << "macro "
        << CHAR_COMMAND << "status "
        << CHAR_COMMAND << "com# "
        << CHAR_COMMAND << "sSPEED "
        << CHAR_COMMAND << "pPIN "
        << CHAR_COMMAND << "#MACRO ... "
        << std::endl;
    std::cout << "\n    To quit: " << CHAR_COMMAND << "quit[Enter] (OR q OR exit)" << std::endl;
    std::cout << "\n    Version " << VERSION << ", (C)2022 JH4VAJ" << std::endl;

    return;
}


int command_analysis(std::string s)
{
    int i, ret;

    char buf[2048];

    ret = 0;

    if ( (s[1] == 'q') || (s.compare(1, strlen("exit"), "exit") == 0) ) {
        ret = 1;          // quit
    }
    else if (s.compare(1, strlen("echocode"), "echocode") == 0) {
        std::cout << "echo code" << std::endl;
        flg_echoback = 2;
    }
    else if (s.compare(1, strlen("echo"), "echo") == 0) {
        std::cout << "echo" << std::endl;
        flg_echoback = 1;
    }
    else if (s.compare(1, strlen("noecho"), "noecho") == 0) {
        std::cout << "no echo" << std::endl;
        flg_echoback = 0;
    }
    else if (s.compare(1, strlen("status"), "status") == 0) {
        print_com_port_num();

        print_speed();

        print_pin_assign();

        switch (flg_echoback) {
            case 1:
                std::cout << "echo";
                break;
            case 2:
                std::cout << "echo code";
                break;
            case 0:
            default:
                std::cout << "no echo";
                break;
        }
        std::cout << std::endl;
    }
    else if (s.compare(1, strlen("com"), "com") == 0) {
        strcpy_s(buf, _countof(buf), s.c_str());
        open_com_port(&buf[4]);
        print_com_port_num();
    }
    else if (s[1] == 's') {
        strcpy_s(buf, _countof(buf), s.c_str());
        if (('0' <= buf[2]) && (buf[2] <= '9')) {
            set_keying_speed(&buf[2]);
            print_speed();
        }
    }
    else if (s[1] == 'p') {
        strncpy_s(buf, s.c_str(), (_countof(buf) - 1));
        set_ctrl_line(&buf[2]);
        print_pin_assign();
    }
    else if (s.compare(1, strlen("macro"), "macro") == 0) {
        for (i = 0; i < (int)strlen(macro_chars); i++) {
            std::cout << macro_chars[i] << " " << cw_code[macro_chars[i]] << std::endl;
        }
    }
    else if (is_macro(s[1]) == TRUE) {
        strncpy_s(buf, s.c_str(), (_countof(buf) - 1));
        set_macro_code(&buf[1]);
        std::cout << s[1] << " " << cw_code[s[1]] << std::endl;
    }
    else if (s.compare(1, strlen("help"), "help") == 0) {
        print_usage();
    }

    return(ret);
}





int main(int argc, char* argv[])
{
    std::string s;

    int i;
    bool flg_nospace;

    com_port_num = 0;

    time_dit = 80;
    flg_longer_interval = FALSE;

    pin_dit_set = SETRTS;
    pin_dit_clr = CLRRTS;
    pin_dah_set = SETDTR;
    pin_dah_clr = CLRDTR;
    flg_is_straight_key = FALSE;

    char buf2[32];
    snprintf(buf2, sizeof(buf2), "%d", KEY_SPEED_DEFAULT);
    set_keying_speed(buf2);


    if (!SetConsoleCtrlHandler(CtrlHandler, TRUE)) {
        exit(1);
    }

    my_name = argv[0];

    if (argc <= 1) {    
        print_usage();
        exit(0);
    }


    if (argc >= 2) {
        if (open_com_port(argv[1]) != TRUE) {
            exit(1);
        }
    }

    if (argc >= 3) {
        if (is_macro(argv[2][0]) == FALSE) {
            if (set_keying_speed(argv[2]) != TRUE) {
                exit(1);
            }
        }
    }

    if (argc >= 4) {
        if (is_macro(argv[3][0]) == FALSE) {
            if (set_ctrl_line(argv[3]) != TRUE) {
                exit(1);
            }
        }
    }

    char buf[] = "|the quick brown fox jumps over the lazy dog 1234567890 ?(/-+=@,. ";
    set_macro_code(buf);                    // テスト用固定文字列
    for (i = 2; i < argc; i++) {
        set_macro_code(argv[i]);
    }

    flg_echoback = 0;

    std::cout << STR_PROMPT;


    while (std::getline(std::cin, s)) {
        // std::transform(s.begin(), s.end(), s.begin(), std::tolower);
        // #include <regex> を入れるとなぜかtransformがコンパイルエラーになるので仕方なく自前関数
        s = to_lower_case(s);

        if (s[0] == CHAR_COMMAND) { // コマンド処理
            if (command_analysis(s) == 0) {
                std::cout << STR_PROMPT;
                continue;
            }
            else {
                break;  // quit
            }
        }


        // マクロ展開
        // 第2引数でエスケープしなければならない場合があるので変数化できず。
        // 上手いアイデアが浮かばないので残念ながらベタ書き。
        // マクロに使う文字を変更する場合は、グローバル変数の
        //      const char  macro_chars[] = "#$%&|";    // マクロで使用する文字
        // とここのベタ書き部分を書き換える。良いアイデア募集。
        s = std::regex_replace(s, std::regex("#"),   cw_code['#']);
        s = std::regex_replace(s, std::regex("\\$"), cw_code['$']);
        s = std::regex_replace(s, std::regex("%"),   cw_code['%']);
        s = std::regex_replace(s, std::regex("\\&"), cw_code['&']);
        s = std::regex_replace(s, std::regex("\\|"), cw_code['|']);
        // std::cout << s << std::endl;
        // std::cout << s.length() << std::endl;


        flg_nospace = FALSE;
        flg_break = FALSE;

        for (i = 0; i < ((int)s.length() - 1); i++) {   // 符号処理
            // std::cout << s[i] << std::endl;
            // std::cout << cw_code[s[i]] << std::endl;

            if (flg_break == TRUE) {
                break;
            }

            switch (s[i]) {
                case '~':
                    flg_nospace = TRUE;
                    break;
                case ' ':
                    flg_nospace = FALSE;
                    char_to_cw(s[i], flg_nospace);
                    break;
                default:
                    char_to_cw(s[i], flg_nospace);
                    break;
            }
        }

        if (flg_echoback == 1) {
            std::cout << std::endl;
        }

        std::cout << STR_PROMPT;
    }

    CloseHandle(hCOM);

    exit(0);
}

